﻿using System;
using System.Collections.Generic;
using System.IO;

namespace bankProductAdvertising.Class
{
	public class UploadDetails
	{
		private Dictionary<String, Customer> customerDetail;
		private Dictionary<String, Product> productDetail;
		private Dictionary<String, BankSalesPerson> bankSalesPersonDetail;

		public Dictionary<String, Customer> CustomerDetail { get => customerDetail; set => customerDetail = value; }
		public Dictionary<String, Product> ProductDetail { get => productDetail; set => productDetail = value; }
		public Dictionary<String, BankSalesPerson> BankSalesPersonDetail { get => bankSalesPersonDetail; set => bankSalesPersonDetail = value; }

		public UploadDetails()
		{
			Console.WriteLine("Loading...");
			this.customerDetail = new Dictionary<String, Customer>();
			this.productDetail = new Dictionary<String, Product>();
			this.bankSalesPersonDetail = new Dictionary<String, BankSalesPerson>();
			loadProductDetails();
			loadCustomerDetails();
			loadBankSalesDetails();
		}

		public void loadCustomerDetails()
		{
			using (StreamReader reader = new StreamReader(@"../../Resources/CustomerList.csv")) {
				while (!reader.EndOfStream) {
					String line = reader.ReadLine();
					String[] values = line.Split('|');
					Customer customer = new Customer(values[0], values[1], values[2], values[3]);
					String[] products = values[4].Split(',');
					for (Int32 i = 0; i < products.Length; i++) {
						customer.addProduct(this.getProductById(products[i]));
					}
					this.customerDetail.Add(customer.Id, customer);
				}
			}

		}

		public void loadBankSalesDetails()
		{
			using (StreamReader reader = new StreamReader(@"../../Resources/BankSalesList.csv")) {
				while (!reader.EndOfStream) {
					String line = reader.ReadLine();
					String[] values = line.Split('|');
					BankSalesPerson bankSalesPerson = new BankSalesPerson(values[0], values[1], values[2], values[3], values[4]);
					this.bankSalesPersonDetail.Add(bankSalesPerson.Id, bankSalesPerson);
				}
			}
		}

		public void loadProductDetails()
		{
			using (StreamReader reader = new StreamReader(@"../../Resources/ProductsList.csv")) {
				while (!reader.EndOfStream) {
					String line = reader.ReadLine();
					String[] values = line.Split('|');
					Product product = new Product(values[0], values[1]);
					this.productDetail.Add(product.Id, product);
				}
			}
		}

		private Product getProductById(String productId)
		{
			Product productToReturn = null;
			this.productDetail.TryGetValue(productId, out productToReturn);
			return productToReturn;
		}
	}
}
